
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>基于redis的分布式锁的分析与实践 / 憋错料</title>

    <meta name="description" content="基于redis的分布式锁的分析与实践 转:https://my.oschina.net/wnjustdoit/blog/1606215 前言:在分布式环境中,我们经常使用锁来进行并发控制,锁可分为乐观锁和悲观锁,基于数据库版本戳的实现是乐观锁,基于redis或zookeeper的实现可认为是悲观锁了.乐观锁和悲观锁最根本的区别在于线程之间是否相互阻塞. 那么,本文主要来讨论基于redis的分布式锁算法问题. 从2.6.12版本开始,redis为SET命令增加了一系列选项(SET key value [EX seconds] [PX">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">基于redis的分布式锁的分析与实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>转：<a href="https://my.oschina.net/wnjustdoit/blog/1606215" rel="external nofollow noreferrer">https://my.oschina.net/wnjustdoit/blog/1606215</a></p>
<p>前言：在分布式环境中，我们经常使用锁来进行并发控制，锁可分为乐观锁和悲观锁，基于数据库版本戳的实现是乐观锁，基于redis或zookeeper的实现可认为是悲观锁了。乐观锁和悲观锁最根本的区别在于线程之间是否相互阻塞。</p>
<p>那么，本文主要来讨论基于redis的分布式锁算法问题。</p>
<p>从2.6.12版本开始，redis为<code>SET</code>命令增加了一系列选项(SET&nbsp;key value [EX seconds] [PX milliseconds] [NX|XX]):</p>
<blockquote><ul>
<li><code>EX</code>&nbsp;<em>seconds</em>&nbsp;&ndash; 设置键key的过期时间，单位时秒</li>
<li><code>PX</code>&nbsp;<em>milliseconds</em>&nbsp;&ndash; 设置键key的过期时间，单位时毫秒</li>
<li><code>NX</code>&nbsp;&ndash; 只有键key不存在的时候才会设置key的值</li>
<li><code>XX</code>&nbsp;&ndash; 只有键key存在的时候才会设置key的值</li>
</ul>
</blockquote>
<p>原文地址：<a href="https://redis.io/commands/set" rel="external nofollow noreferrer">https://redis.io/commands/set</a></p>
<p>中文地址：<a href="http://redis.cn/commands/set.html" rel="external nofollow noreferrer">http://redis.cn/commands/set.html</a></p>
<p>注意:&nbsp;由于<code>SET</code>命令加上选项已经可以完全取代<a href="http://redis.cn/commands/setnx.html" rel="external nofollow noreferrer">SETNX</a>,&nbsp;<a href="http://redis.cn/commands/setex.html" rel="external nofollow noreferrer">SETEX</a>,&nbsp;<a href="http://redis.cn/commands/psetex.html" rel="external nofollow noreferrer">PSETEX</a>的功能，所以在将来的版本中，redis可能会不推荐使用并且最终抛弃这几个命令。</p>
<p>（这里简单提一下，在旧版本的redis中（指2.6.12版本之前），使用redis实现分布式锁一般需要setNX、expire、getSet、del等命令。而且会发现这种实现有很多逻辑判断的原子操作以及本地时间等并没有控制好。）</p>
<p>而在旧版本的redis中，redis的超时时间很难控制，用户迫切需要把setNX和expiration结合为一体的命令，把他们作为一个原子操作，这样新版本的多选项set命令诞生了。然而这并没有完全解决复杂的超时控制带来的问题。</p>
<p>接下来，我们的一切讨论都基于新版redis。</p>
<h4>在这里，我先提出几个在实现redis分布式锁中需要考虑的关键问题</h4>
<p>1、死锁问题；</p>
<p>1.1、为了防止死锁，redis至少需要设置一个超时时间；</p>
<p>1.2、由1.1引申出来，当锁自动释放了，但是程序并没有执行完毕，这时候其他线程又获取到锁执行同样的程序，可能会造成并发问题，这个问题我们需要考虑一下是否归属于分布式锁带来问题的范畴。</p>
<p>2、锁释放问题，这里会有两个问题；</p>
<p>2.1、每个获取redis锁的线程应该释放自己获取到的锁，而不是其他线程的，所以我们需要在每个线程获取锁的时候给锁做上不同的标记以示区分；</p>
<p>2.2、由2.1带来的问题是线程在释放锁的时候需要判断当前锁是否属于自己，如果属于自己才释放，这里涉及到逻辑判断语句，至少是两个操作在进行，那么我们需要考虑这两个操作要在一个原子内执行，否者在两个行为之间可能会有其他线程插入执行，导致程序紊乱。</p>
<p>3、更可靠的锁；</p>
<p>单实例的redis（这里指只有一个master节点）往往是不可靠的，虽然实现起来相对简单一些，但是会面临着宕机等不可用的场景，即使在主从复制的时候也显得并不可靠（因为redis的主从复制往往是异步的）。</p>
<h4>关于Martin Kleppmann的Redlock的分析</h4>
<p>原文地址：<a href="https://redis.io/topics/distlock" rel="external nofollow noreferrer">https://redis.io/topics/distlock</a></p>
<p>中文地址：<a href="http://redis.cn/topics/distlock.html" rel="external nofollow noreferrer">http://redis.cn/topics/distlock.html</a></p>
<p>文章分析得出，这种算法只需具备3个特性就可以实现一个最低保障的分布式锁。</p>
<blockquote><ol>
<li>安全属性（Safety property）: 独享（相互排斥）。在任意一个时刻，只有一个客户端持有锁。</li>
<li>活性A(Liveness property A): 无死锁。即便持有锁的客户端崩溃（crashed)或者网络被分裂（gets partitioned)，锁仍然可以被获取。</li>
<li>活性B(Liveness property B): 容错。 只要大部分Redis节点都活着，客户端就可以获取和释放锁.</li>
</ol>
</blockquote>
<p>我们来分析一下：</p>
<p>第一点安全属性意味着悲观锁（互斥锁）是我们做redis分布式锁的前提，否者将可能造成并发；</p>
<p>第二点表明为了避免死锁，我们需要设置锁超时时间，保证在一定的时间过后，锁可以重新被利用；</p>
<p>第三点是说对于客户端来说，获取锁和手动释放锁可以有更高的可靠性。</p>
<p>更进一步分析，结合上文提到的关键问题，这里可以引申出另外的两个问题：</p>
<p>1、怎么才能合理判断程序真正处理的有效时间范围？（这里有个时间偏移的问题）</p>
<p>2、redis Master节点宕机后恢复（可能还没有持久化到磁盘）、主从节点切换，(N/2)+1这里的N应该怎么动态计算更合理？</p>
<h4>接下来再看，redis之父<a href="http://antirez.com/user/antirez" rel="external nofollow noreferrer">antirez</a>对Redlock的评价</h4>
<p>原文地址：<a href="http://antirez.com/news/101" rel="external nofollow noreferrer">http://antirez.com/news/101</a></p>
<p>文中主要提到了网络延迟和本地时钟的修改（不管是时间服务器或人为修改）对这种算法可能造成的影响。</p>
<h4>最后，来点实践吧</h4>
<p><em>I、传统的单实例redis分布式锁实现（关键步骤）</em></p>
<p>获取锁（含自动释放锁）：</p>
<blockquote><pre><code>SET resource_name my_random_value NX PX 30000</code></pre>
</blockquote>
<p>手动删除锁（Lua脚本）：</p>
<blockquote><pre><code>if redis.call("get",KEYS[1]) == ARGV[1] then
    return redis.call("del",KEYS[1])
else
    return 0
end</code></pre>
</blockquote>
<p><em>&nbsp;II、分布式环境的redis（多master节点）的分布式锁实现</em></p>
<p>为了保证在尽可能短的时间内获取到(N/2)+1个节点的锁，可以并行去获取各个节点的锁（当然，并行可能需要消耗更多的资源，因为串行只需要count到足够数量的锁就可以停止获取了）；</p>
<p>另外，怎么动态实时统一获取redis master nodes需要更进一步去思考了。</p>
<h4>QA，补充一下说明（以下为我与朋友沟通的情况，以说明文中大家可能不够明白的地方）：</h4>
<blockquote><p>1、在关键问题2.1中，删除就删除了，会造成什么问题？</p>
<p>线程A超时，准备删除锁；但此时的锁属于线程B；线程B还没执行完，线程A把锁删除了，这时线程C获取到锁，同时执行程序；所以不能乱删。</p>
<p>2、在关键问题2.2中，只要在key生成时，跟线程相关就不用考虑这个问题了吗？</p>
<p>不同的线程执行程序，线程之间肯虽然有差异呀，然后在redis锁的value设置有线程信息，比如线程id或线程名称，是分布式环境的话加个机器id前缀咯（类似于twitter的snowflake算法！），但是在del命令只会涉及到key，不会再次检查value，所以还是需要lua脚本控制if(condition){xxx}的原子性。</p>
<p>3、为什么两个线程都会去删除锁？（貌似重复的问题。不管怎样，还是耐心解答吧）</p>
<p>每个线程只能管理自己的锁，不能管理别人线程的锁啊。这里可以联想一下ThreadLocal。</p>
<p>4、如果加锁的线程挂了怎么办？只能等待自动超时？</p>
<p>看你怎么写程序的了，一种是问题3的回答；另外，那就自动超时咯。这种情况也适用于网络over了。</p>
<p>5、时间太长，程序异常就会蛋疼，时间太短，就会出现程序还没有处理完就超时了，这岂不是很尴尬？</p>
<p>是呀，所以需要更好的衡量这个超时时间的设置。</p></blockquote>
<p>附加：</p>
<p>基于redis的分布式锁实现客户端Redisson：<a href="https://github.com/redisson/redisson/wiki/8.-Distributed-locks-and-synchronizers" rel="external nofollow noreferrer">https://github.com/redisson/redisson/wiki/8.-Distributed-locks-and-synchronizers</a></p>
<p>基于zookeeper的分布式锁实现：<a href="https://curator.apache.org/curator-recipes/shared-reentrant-lock.html" rel="external nofollow noreferrer">http://curator.apache.org/curator-recipes/shared-reentrant-lock.html</a></p>

<p>原文地址：https://www.cnblogs.com/wjqhuaxia/p/11762224.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 23:08:22 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e9%97%ae%e9%a2%98/" title="问题">问题</a>, <a href="https://www.biecuoliao.com/tag/%e5%b8%a6%e6%9d%a5/" title="带来">带来</a>, <a href="https://www.biecuoliao.com/tag/std/" title="std">std</a>, <a href="https://www.biecuoliao.com/tag/%e6%9c%ac%e5%9c%b0/" title="本地">本地</a>, <a href="https://www.biecuoliao.com/tag/lua/" title="lua">lua</a>, <a href="https://www.biecuoliao.com/tag/ruby/" title="ruby">ruby</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%9a%e9%80%89/" title="多选">多选</a>, <a href="https://www.biecuoliao.com/tag/rand/" title="rand">rand</a>, <a href="https://www.biecuoliao.com/tag/news/" title="news">news</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>基于redis的分布式锁的分析与实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyjxBn0.html" rel="bookmark">基于Redis的分布式锁到底安全吗（上）？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网上有关Redis分布式锁的文章可谓多如牛毛了,不信的话你可以拿关键词&quot;Redis 分布式锁&quot;随便到哪个搜索引擎上去搜索一下就知道了.这些文章的思路大体相近,给出的实现算法也看似合乎逻辑,但当我们着手去实现它们的时候,却发现如果你越是仔细推敲,疑虑也就越来越多. 实际上,大概在一年以前,关于Redis分布式锁的安全性问题,在分布式系统专家Martin Kleppmann和Redis的作者antirez之间就发生过一场争论.由于对这个问题一直以来比较关注,所以我前些日子仔细阅读了与这场争			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JBBrA4.html" rel="bookmark">基于redis的分布式锁（不适合用于生产环境）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于redis的分布式锁 1 介绍 这篇博文讲介绍如何一步步构建一个基于Redis的分布式锁.会从最原始的版本开始,然后根据问题进行调整,最后完成一个较为合理的分布式锁. 本篇文章会将分布式锁的实现分为两部分,一个是单机环境,另一个是集群环境下的Redis锁实现.在介绍分布式锁的实现之前,先来了解下分布式锁的一些信息. 2 分布式锁 2.1 什么是分布式锁? 分布式锁是控制分布式系统或不同系统之间共同访问共享资源的一种锁实现,如果不同的系统或同一个系统的不同主机之间共享了某个资源时,往往需要互斥			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgYXdn3.html" rel="bookmark">基于redis的分布式锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;?php /** * 基于redis的分布式锁 * * 参考开源代码: * http://nleach.com/post/31299575840/redis-mutex-in-php * * https://gist.github.com/nickyleach/3694555 */ pc_base::load_sys_class('cache_redis', '', 0); class dist_key_redis { //锁的超时时间 const TIMEOUT = 20; const SL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xAagL3.html" rel="bookmark">转载：基于Redis实现分布式锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载:基于Redis实现分布式锁  ,出处: http://blog.csdn.net/ugg/article/details/41894947 背景在很多互联网产品应用中,有些场景需要加锁处理,比如:秒杀,全局递增ID,楼层生成等等.大部分的解决方案是基于DB实现的,Redis为单进程单线程模式,采用队列模式将并发访问变成串行访问,且多客户端对Redis的连接并不存在竞争关系.其次Redis提供一些命令SETNX,GETSET,可以方便实现分布式锁机制. Redis命令介绍使用Redis实现分			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49gAeX0.html" rel="bookmark">基于redis的分布式锁实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于分布式锁 很久之前有讲过并发编程中的锁并发编程的锁机制:synchronized和lock.在单进程的系统中,当存在多个线程可以同时改变某个变量时,就需要对变量或代码块做同步,使其在修改这种变量时能够线性执行消除并发修改变量.而同步的本质是通过锁来实现的.为了实现多个线程在一个时刻同一个代码块只能有一个线程可执行,那么需要在某个地方做个标记,这个标记必须每个线程都能看到,当标记不存在时可以设置该标记,其余后续线程发现已经有标记了则等待拥有标记的线程结束同步代码块取消标记后再去尝试设置标记.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWXVnl0.html" rel="bookmark">&lbrack;Redis&rsqb; 基于redis的分布式锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言分布式锁一般有三种实现方式:1. 数据库乐观锁:2. 基于Redis的分布式锁:3. 基于ZooKeeper的分布式锁.本篇博客将介绍第二种方式,基于Redis实现分布式锁. 可靠性首先,为了确保分布式锁可用,我们至少要确保锁的实现同时满足以下四个条件: 互斥性.在任意时刻,只有一个客户端能持有锁.不会发生死锁.即使有一个客户端在持有锁的期间崩溃而没有主动解锁,也能保证后续其他客户端能加锁.具有容错性.只要大部分的Redis节点正常运行,客户端就可以加锁和解锁.解铃还须系铃人.加锁和解锁必须			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MygQjY3.html" rel="bookmark">python基于redis实现分布式锁</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阅读目录 什么事分布式锁 基于redis实现分布式锁 一.什么是分布式锁 我们在开发应用的时候,如果需要对某一个共享变量进行多线程同步访问的时候,可以使用我们学到的锁进行处理,并且可以完美的运行,毫无Bug! 注意这是单机应用,后来业务发展,需要做集群,一个应用需要部署到几台机器上然后做负载均衡,大致如下图: 上图可以看到,变量A存在三个服务器内存中(这个变量A主要体现是在一个类中的一个成员变量,是一个有状态的对象),如果不加任何控制的话,变量A同时都会在分配一块内存,三个请求发过来同时对这个变			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vgxV64.html" rel="bookmark">基于Redis的分布式锁和Redlock算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 前言 前面写了4篇Redis底层实现和工程架构相关文章,感兴趣的读者可以回顾一下: Redis面试热点之底层实现篇-1 Redis面试热点之底层实现篇-2 Redis面试热点之工程架构篇-1 Redis面试热点之工程架构篇-2 今天开始来和大家一起学习一下Redis实际应用篇,会写几个Redis的常见应用. 在我看来Redis最为典型的应用就是作为分布式缓存系统,其他的一些应用本质上并不是杀手锏功能,是基于Redis支持的数据类型和分布式架构来实现的,属于小而美的应用. 结合笔者的日常工作,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JAY8B3.html" rel="bookmark">身为一枚优秀的程序员必备的基于Redis的分布式锁和Redlock算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 前言 今天开始来和大家一起学习一下Redis实际应用篇,会写几个Redis的常见应用. 在我看来Redis最为典型的应用就是作为分布式缓存系统,其他的一些应用本质上并不是杀手锏功能,是基于Redis支持的数据类型和分布式架构来实现的,属于小而美的应用. 结合笔者的日常工作,今天和大家一起研究下基于Redis的分布式锁和Redlock算法的一些事情. 2.初识锁 1. 锁的双面性 现在我们写的程序基本上都有一定的并发性,要么单台多进线程.要么多台机器集群化,在仅读的场景下是不需要加锁的,因为数			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4NK9GM.html" rel="bookmark" class="title">jquery过滤选择器-----------（屬性过滤选择器）</a>
					<div>
						1.介紹 2.程序 1 &lt;!DOCTYPE html&gt; 2 &lt;html&gt; 3 &lt;head&gt; 4 &lt;meta charset=&quot;UTF-8&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQYyB3.html" rel="bookmark" class="title">流量主第三篇：003&lowbar;教你微信如何加精准粉丝和赚钱</a>
					<div>
						导读:比较有干货的一篇文章,虽然上不了台面,但适合个人操作,而且有效果. 为什么要做微信,如果你仔细逛逛淘宝,你会发现.聪明的商家都在把用户引导微信上,即便是做自媒体的微博大号,也在把粉丝引导微信上. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4APE1z3.html" rel="bookmark" class="title">Spring Batch Hello World Example</a>
					<div>
						Spring Batch is a framework for batch processing – execution of a series of jobs. In Spring Batch, A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0knqNbM.html" rel="bookmark" class="title">python pandas 获取列数据的几种方法及书写形式比较</a>
					<div>
						pandas获取列数据位常用功能,但在写法上还有些要注意的地方,在这里总结一下: ''' author: zilu.tang 2015-12-31 ''' import pandas as pd da ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXQ6X0.html" rel="bookmark" class="title">RotorInsa&period;v3&period;4&period;2有限元软件，进行回转体挠度方面的动态模拟</a>
					<div>
						ETA.CAD.Translator.v1.200704 ETA.VPG.v3.2 汽车整车仿真软件 ETA_DYNAFORM_V5.6(多语言版,包括中文) (DYNAFORM 是ETA开发的用于板 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awJQA4.html" rel="bookmark" class="title">Give it five minutes</a>
					<div>
						A few years ago I used to be a hothead. Whenever anyone said anything, I’d think of a way to disagre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDelAM.html" rel="bookmark" class="title">Android学习之压缩图片到指定大小</a>
					<div>
						关于图片压缩,是为了上传服务器时有些地方有大小限制,因此,这里我总结了两种方法,个人感觉方法一比较准确一点. 方法一: * 图片压缩方法一 * * 计算 bitmap大小,如果超过64kb,则进行压缩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MB1wdY4.html" rel="bookmark" class="title">半平面交 模板    poj  3335   poj 3130   poj 1474    &NewLine;判断半平面交是否为空集</a>
					<div>
						半平面交模板 const double pi= acos(-1.0); #define arc(x) (x / 180 * pi) const double EPS = 1e-8; const int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qN5j3.html" rel="bookmark" class="title">Socket异步通信学习一</a>
					<div>
						最近在做一个频谱管理项目,负责通信模块,自己也是小白,重头学起,直至今天通信基本框架已经完成,把自己在学习中的心得与大家分享一下,做一个socket系列的博文,顺便加固一下自己对socket通信的认识 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvO7X3.html" rel="bookmark" class="title">CDN（内容分发网络）技术原理</a>
					<div>
						原文转自:http://kb.cnblogs.com/page/121664/ 1. 前言 Internet的高速发展,给人们的工作和生活带来了极大的便利,对Internet的服务品质和访问速度要求越 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n5DvvM.html" rel="bookmark" class="title">cygwin简介及使用</a>
					<div>
						一个是真实的假货,一个是冒牌的真品前指 Cygwin,后指 Linux/VMWare 路不管平还是陡,终归你要走的,如果你愿意投入到linux开发的社群中来,不会安装linux系统,不会配置工作环境是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y77pq4.html" rel="bookmark" class="title">gic的其他一些术语</a>
					<div>
						前面几节翻译中,我们简单介绍过中断的状态的一些术语,比如active之类的,本文补充一些其他术语,可以更好的帮助我们学习gic: PPI: private peripheral interrupt:某 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7Pry4.html" rel="bookmark" class="title">深入学习sea&period;js</a>
					<div>
						入门学习了文档之后,在深入学习里面的一些有趣的知识点 =================================== 一.配置 seajs.config({ alias:( a3:'./js/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Njz864.html" rel="bookmark" class="title">for循环、in、not in</a>
					<div>
						for循环可以遍历集合中任意一个元素 1 a = [&quot;hello&quot;, &quot;world&quot;, &quot;dlrb&quot;] 2 for b in a: 3 pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aRNEk3.html" rel="bookmark" class="title">str类型特有和公共方法以及切片和索引的区别</a>
					<div>
						字符串的创建方式 1. s = &quot;Lebron James&quot; 2. s = str(&quot;Lebron James&quot;)  #调用str对象进行创建 相当于str._ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWydv0.html" rel="bookmark" class="title">单表ORM框架</a>
					<div>
						基本描述 1.首先是一个单表的ORM框架,多表连接查询请使用视图或者使用SqlHelper查询,然后转换成实体集合. 2.目前仅完成基本结构和MySQL部分. 3.目前欠缺Lambda表达式解析,所以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPexVv0.html" rel="bookmark" class="title">Django 编写博客网站的用户管理部分&lpar;采用自有的 django&period;contrib&period;auth&rpar; 2&period; 登陆登出和用户信息管理</a>
					<div>
						续前Django 编写博客网站的用户管理部分(采用自有的 django.contrib.auth) 1. 注册部分 项目工具:Python 2.7.11  Django 1.10.2  Bootstr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQr6v0.html" rel="bookmark" class="title">基于Servlet的验证码实现</a>
					<div>
						话不多说先上代码 public class VerCodeServlet extends HttpServlet { private static final long serialVersionUI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDnmJo3.html" rel="bookmark" class="title">java web&lpar;转&rpar;</a>
					<div>
						装载:http://www.oschina.net/question/12_52027 OSCHINA 软件库有一个分类——Web框架,该分类中包含多种编程语言的将近500个项目. Web框架是开发者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k2RYlM.html" rel="bookmark" class="title">BestCoder Round &num;3  A  hdu 4907 Task schedule</a>
					<div>
						Task schedule                                                                        Time Limit: 200 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
